#include "WiFi.h"
#include <Arduino_JSON.h>
#include <HTTPClient.h>
#include <ESP32Servo.h>

const char* ssid = "yourNetworkName";
const char* password =  "yourNetworkPass";

Servo myservo;

void setup() {
 
  Serial.begin(115200);
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.println("Connecting to WiFi..");
  }
 
  Serial.println("Connected to the WiFi network");

  myservo.attach(18);
  myservo.write(0);
}
 
void loop() {
    if(WiFi.status()== WL_CONNECTED){
          
        HTTPClient http;
        http.begin("https://embsmart.herokuapp.com/embedded?name=password");   
        int httpCode = http.GET();
          
        if (httpCode>0){
            String payload = http.getString();
            JSONVar myObject = JSON.parse(payload);
            JSONVar mykey = myObject.keys();
            int state = myObject[mykey[2]]
            Serial.println(httpCode);

            if (state) {
                for (int i=0;i<=180;i++) myservo.write(i);
                delay(3000);
                for (int i=180;i>=0;i--) myservo.write(i);
                http.PUT("{\"data\":0}");    
            }
        } else {
            Serial.println("Error on HTTP request (in Password part)");
        }

        delay(1000);
        http.end();
    } else {
          Serial.println("Error in WiFi connection");
    }
}
