#include <WiFi.h>
#include <HTTPClient.h>
#include <AdafruitIO_Feed.h>
#include "AdafruitIO_WiFi.h"

//cosntants for the pins where sensors are plugged into.
#define sensorPin 35
#define ledPin1 18
#define ledPin2 5
#define ledPin3 17
#define ledPin4 16
#define ledPin5 4

// Adafruit IO setup
#define IO_USERNAME  "SP_TS1"
#define IO_KEY "aio_gJTY21rmgBsXWaBTFnnxRJnbfeUm"



//Set up some global variables for the light level an initial value.
int lightVal;   // light reading
int count_on = 0;
int count_off = 0;
int led = 0;
int countADA = 0;

// initialize WIFI setup
const char* ssid = "Taro";
const char* password = "03021144@";

// set up the 'temperature' feeds
AdafruitIO_WiFi io(IO_USERNAME, IO_KEY, ssid, password);
AdafruitIO_Feed *light = io.feed("lightval");

void setup()
{
  Serial.begin(9600);
  pinMode(ledPin1, OUTPUT);
  pinMode(ledPin2, OUTPUT);
  pinMode(ledPin3, OUTPUT);
  pinMode(ledPin4, OUTPUT);
  pinMode(ledPin5, OUTPUT);

  //connect to WiFi
  WiFi.begin(ssid, password);
  delay(10000);
  while (WiFi.status() != WL_CONNECTED) {
    delay(3000);
    Serial.println("Connecting to WiFi..");
  }
  
  Serial.println("Connected to the WiFi network");
  // connect to io.adafruit.com
  Serial.print("Connecting to Adafruit IO");
  io.connect();

  // wait for a connection
  while(io.status() < AIO_CONNECTED) {
    Serial.print(".");
    delay(500);
  }

  // we are connected
  Serial.println();
  Serial.println(io.statusText());
}

void loop()
{
  if ((WiFi.status() == WL_CONNECTED)) {
    HTTPClient http;
    http.begin("https://embsmart.herokuapp.com/embedded?name=light");
    }
  
  int lightVal = analogRead(sensorPin); // read the current light levels
  //if lightVal is less than our initial reading withing a threshold then it is dark.
  if (countADA == 8){
    countADA = 0;
    light->save(lightVal);
  }
  countADA+=1;
  Serial.println(lightVal);
  if(lightVal  <  2000)
  {
      count_on+=1;
      count_off=0;
      if (count_on == 2 && led==0){
        led = 1;
        count_on = 0;
        digitalWrite (ledPin1, HIGH); // turn on light
        digitalWrite (ledPin2, HIGH);
        digitalWrite (ledPin3, HIGH);
        digitalWrite (ledPin4, HIGH);
        digitalWrite (ledPin5, HIGH);
        if(WiFi.status()== WL_CONNECTED){
          HTTPClient http;   
          http.begin("https://embsmart.herokuapp.com/embedded?name=light");
          http.addHeader("Content-Type", "application/json");            
          int httpResponseCode = http.PUT("{\"data\":1}");    
          if(httpResponseCode>0){
            String response = http.getString();   
            Serial.println(httpResponseCode);
            Serial.println(response); 
           }
          else{
            Serial.print("Error on sending PUT Request: ");
            Serial.println(httpResponseCode);
          }
          http.end();
     }
     else{
      Serial.println("Error in WiFi connection");
     }
     }     
  }
  //otherwise, it is bright
  else
  {
    count_off+=1;
    count_on = 0;
    if (count_off==2 && led==1){
       led = 0;
       count_off = 0;
       digitalWrite (ledPin1, LOW); // turn off light
       digitalWrite (ledPin2, LOW);
       digitalWrite (ledPin3, LOW);
       digitalWrite (ledPin4, LOW);
       digitalWrite (ledPin5, LOW);
        if(WiFi.status()== WL_CONNECTED){
          HTTPClient http;   
          http.begin("https://embsmart.herokuapp.com/embedded?name=light");
          http.addHeader("Content-Type", "application/json");            
          int httpResponseCode = http.PUT("{\"data\":0}");    
          if(httpResponseCode>0){
            String response = http.getString();   
            Serial.println(httpResponseCode);
            Serial.println(response); 
           }
          else{
            Serial.print("Error on sending PUT Request: ");
            Serial.println(httpResponseCode);
          }
          http.end();
     }
     else{
      Serial.println("Error in WiFi connection");
     }
    }   
  }
  delay(1000);
 }
