#include <WiFi.h>
#include <Arduino_JSON.h>
#include <HTTPClient.h>
#include <AdafruitIO_Feed.h>
#include "AdafruitIO_WiFi.h"
// initialize WIFI setup
const char* ssid = "WMC-WIFI";
const char* password = "wmc@2020";
const int buzzerPin = 23;      //define the buzzer pin


// Adafruit IO setup
#define IO_USERNAME  "SP_TS1"
#define IO_KEY       "aio_gJTY21rmgBsXWaBTFnnxRJnbfeUm"

// set up the 'temperature' feeds
AdafruitIO_WiFi io(IO_USERNAME, IO_KEY, ssid, password);
AdafruitIO_Feed *buzzer = io.feed("buzzer");


void setup(){
  ledcSetup(0,1E5,12);
  ledcAttachPin(buzzerPin,0);
  Serial.begin(115200);
  delay(3000);
  
  
  // connect WIFI
  WiFi.begin(ssid, password);
  delay(5000);
  while (WiFi.status() != WL_CONNECTED) {
    delay(3000);
    Serial.println("Connecting to WiFi..");
  }
  
  Serial.println("Connected to the WiFi network");
  // connect to io.adafruit.com
  Serial.print("Connecting to Adafruit IO");
  io.connect();

  // wait for a connection
  while(io.status() < AIO_CONNECTED) {
    Serial.print(".");
    delay(500);
  }

  // we are connected
  Serial.println();
  Serial.println(io.statusText());
  
}

void loop(){
  
  if ((WiFi.status() == WL_CONNECTED)) {
    HTTPClient http;

    // Temperature Part    
    
    http.begin("https://embsmart.herokuapp.com/embedded?name=temperature");
    int httpCode = http.GET();
    if (httpCode>0){
      String payload = http.getString();
      JSONVar myObject = JSON.parse(payload);
      JSONVar mykey = myObject.keys();
      double mytemp = myObject[mykey[2]];
      Serial.println(httpCode);
      Serial.println(mytemp);

     //Buzzer   
     if(mytemp > 32){
          ledcWriteTone(0,800);
          delay(2000);
          uint8_t octave = 1;
          ledcWriteNote(0,NOTE_C,octave);  
          delay(500);
          //ada
          buzzer->save(1);
      }
      else{
          buzzer->save(0);
        }
   }
    else {
      Serial.println("Error on HTTP request (in Temperature part)");
    }
   
  http.end();
  }
}
