#include <WiFi.h>
#include <HTTPClient.h>

float temp, tee;
float R1 = 10000;
float logR2, R2, T;
float c1 = 1.009249522e-03, c2 = 2.378405444e-04, c3 = 2.019202697e-07;
int tempPin = 33;

// initialize WIFI setup
const char* ssid = "iPhoneM";
const char* password = "12345678";

void setup() {
   Serial.begin(9600);

   //connect to WiFi
   WiFi.begin(ssid, password);
   delay(10000);
   while (WiFi.status() != WL_CONNECTED) {
      delay(3000);
      Serial.println("Connecting to WiFi..");
   }
   Serial.println("Connected to the WiFi network");
}

void loop() {
   if ((WiFi.status() == WL_CONNECTED)) {
    HTTPClient http;
    http.begin("https://embsmart.herokuapp.com/embedded?name=light");
   }
    
   temp = analogRead(tempPin);
   tee = temp/68;
   // convert the analog volt to its temperature equivalent
   Serial.print("TEMPERATURE = ");
   Serial.print(tee); // display temperature value
   Serial.print("*C");
   Serial.println();
   delay(1000); // update sensor reading each one second

   if(WiFi.status()== WL_CONNECTED){
          HTTPClient http;   
          http.begin("https://embsmart.herokuapp.com/embedded?name=temperature");
          http.addHeader("Content-Type", "application/json");            
          int httpResponseCode = http.PUT("{\"data\":" + String(tee) + "}");    
          if(httpResponseCode>0){
            String response = http.getString();   
            Serial.println(httpResponseCode);
            Serial.println(response); 
           }
          else{
            Serial.print("Error on sending PUT Request: ");
            Serial.println(httpResponseCode);
          }
          http.end();
   }
}
